getwd()
setwd("C:/Users/Claire/Documents/RUSP")

#Exerccios 8. 
#Reamostragem e Simulao

eutad=read.table("palmitos.txt", dec=".", as.is=T, header=T)
eutad
head(eutad)
str(eutad)
names(eutad)
tail(eutad)
eutad[is.na(eutad$tag)|is.na(eutad$gx)|is.na(eutad$gy),]

#Crie o objeto para guardar as distncias entre cada indivduo:
#criando um objeto vazio:

dist=matrix(NA, ncol=102, nrow=102)
dist
head(dist)


#Calcule a distncia observada entre cada indivduo e guarde o 
#resultados em dist:

#repeties de funes...
for(i in 1:101)
    {
        for(j in (i+1):102)
            {
                difx2=(eutad$gx[i]-eutad$gx[j])^2#diferena do valor da posio um da posio 2.
                dify2=(eutad$gy[i]-eutad$gy[j])^2#o mesmo para a varivel gy.
                dist[i,j]=sqrt(difx2 + dify2)#da matriz que eu criei, raiz quadrada da soma da diferena
                dist[j,i]=sqrt(difx2 + dify2)
            }
          
    }
dist
head(dist)
#calcule o parmetro chamado de distncia mdia do vizinho mais prximo (MNN):

(nn=apply(dist, MARGIN=1, FUN=min, na.rm=TRUE))#no objeto dist, selecionar os valores de distncia mnimas
(mnn=mean(nn))#mdia do vizinho mais prximo.

?apply


#Simulando (usa parte do que foi feito acima)

resultado=rep(NA,1000)#objeto vetor com 1000 posies sem valores
resultado[1]=mnn
resultado
head(resultado)
?runif
for(k in 2:1000)
	{
	xsim=round(runif(102,0,320),1)#isso para os valores de x
	ysim=round(runif(102,0,320),1)#isso para os valores de y.
	distancia=matrix(NA, ncol=102, nrow=102)#matriz onde os resultados dessa primeira parte sero guardados.
	for(i in 1:101)
    		{
        		for(j in (i+1):102)
            		{
                			difx=(xsim[i]-xsim[j])^2#diferena do valor da posio um da posio 2.
                			dify=(ysim[i]-ysim[j])^2#o mesmo para a varivel gy.
                			distancia[i,j]=sqrt(difx + dify)#da matriz que eu criei, raiz quadrada da soma da diferena
                			distancia[j,i]=sqrt(difx + dify)
				}
          
    		}
	
	minimo=apply(distancia, MARGIN=1, FUN=min, na.rm=TRUE)
	media=mean(minimo)
	resultado[k]=media#vetor onde as mdias sero guardadas.
	}

resultado


resultado = rep(NA, 1000) #cria vetor de NA para guardar resultado
resultado[1] = mnn #coloca observado na primeira posio do vetor

for(k in 2:1000) #faz 999 simulaes
{
  xsim = runif(102, 0, 320) #sorteia 102 valores de uma distribuio uniforme para x
  ysim = runif(102, 0, 320) #idem pra y
  distsim=matrix(NA, ncol=102, nrow=102)  #cria matriz de NA para guardar resultados
  
  for(i in 1:101) #calcula distncia de cada vizinho
  {
    for(j in (i+1):102)
    {
      difx2sim=(xsim[i]-xsim[j])^2
      dify2sim=(ysim[i]-ysim[j])^2
      distsim[i,j]<-sqrt(difx2sim + dify2sim)
      distsim[j,i]<-sqrt(difx2sim + dify2sim)
    }
  }
  (mins<-apply(distsim, 1, min, na.rm=TRUE)) #distncia minima pra cada palmito
  mediamindist<-mean(mins) #mdia do vizinho mais prximo
  resultado[k] = mediamindist #guarda a mdia no vetor de resultados
}
resultado

#Histograma dos dados simulados
dev.off()
par()
hist(resultado)
abline(v=resultado[1], col="blue")#v  um argumento do abline. indica que eu quero o valor 
#de x para linhas verticais.


#Calcule a probabilidade de uma distribuio espacial aleatria gerar valores iguais ou mais 
#extremos do que o valor MNN observado.

#Distribuio bi
numero=sum(resultado>=resultado[1]|resultado<=resultado[1]*-1)
numero
length(resultado)
numero/length(resultado)




#------------------------ Exerccio 2

#Simulando o teste de uma regresso linear

#O principal teste estatstico de uma regresso linear  que a inclinao do 
#modelo da reta  diferente de zero

dados=read.table("bodybrain.txt", dec=",", sep=";", as.is=T, header=T)
dados
summary(dados)
(str(dados))
head(dados)

#verificando se tem NAs...
dados[is.na(dados$brain),]
dados[is.na(dados$body),]

#omitindo as linhas com NAs
dados=na.omit(dados)

#transformando os dados em log
dados$logbrain=log(dados$brain)

#transformando os dados em log
dados$logbody=log(dados$body)
dados$sample=sample(dados$brain)

head(dados)

#criando um objeto vetor vazio
resultado2=rep(NA,1000)

#calulando as estimativas em cima das observaes 
lmdados=lm(logbrain~logbody,data=dados)
lmdados
coef(lmdados)[2] uso somente os ndices de logbody (pois ele  o valor que me d
#a inclinao da reta). 

#inserindo na posio 1 do objeto vazio criado, as estimativas observadas
resultado2[1]=(coef(lmdados)[2])  # arredondar!!! #coeficeinte que fica na posio dois do resultado 
#do lm, ou seja o valor de b.

resultado2
head(resultado2)

for(i in 2:1000)
	{
	sim.brain=sample(dados$brain)
	resultado2[i]=coef(lm(sim.brain ~ logbody, data=dados))[[2]]	
	}
resultado2

hist(resultado2)
abline(v=resultado2[1], col="blue")
#a linha est no centro da curva, ou seja, o valor de b est entre os valores 
#em que no se espera relao.

v.p= sum(abs(resultado2)>= abs(resultado2[1]))/length(resultado2)
v.p

#no existe uma relao entre as duas vaiveis.  99% de probabilidade de erro ao
#assumir de que hiptese nula est erradda.




