getwd()
setwd("C:/Users/Claire/Documents/RUSP")

################## GRFICO exerccio 1 ########################################

getwd()
setwd("C:/Users/Claire/Documents/RUSP")

saligna=read.csv("esaligna.csv", header=T,sep=",", dec=".",as.is=T)
saligna
str(saligna)
head(saligna)
summary(saligna)

dev.off()
?par
#abrindo o plano de trabalho para a construo do grfico
par() 

#aumentei o tamanho dos crculos em 40%= 0,4 de 1
plot(saligna$ht~saligna$dap,xlab="",ylab="",tcl=0.3,main="Eucalypthus saligna",cex.main=1.8,las=1,cex.axis=1.5,pch=19,,col="red",cex=1.4,bty="l",family="serif")

#aumentei a letra 50% ou seja, 50% de 1=0.5 o que seria cex=1.5. 
mtext("Altura (m)",side=2,cex=1.7,line=3,family="serif")
mtext("Dimetro  altura do peito (cm)",side=1,cex=1.7,line=3,family="serif")
?las
?par

png(file = "saligna.png", bg = "transparent")
dev.off()
graphics.off()


########################   DOIS GRFICOS JUNTOS exerccio 2  ##############################

saligna=read.csv("esaligna.csv", header=T,sep=",", dec=".",as.is=T)
saligna

##GRAFICO BOX PLOT

par(mfrow=c(1, 2))#plano com uma linha e duas colunas para dois grficos lado a lado
par(tcl=0.3,bty="l",cex.axis=1.5,family="serif")#argumentos de parmetros que no consigo definir na funo boxplot
boxplot(dap~talhao, data=saligna,tcl=3,las=1,cex=1.5,family="serif")

mtext("Frequncia de tamanhos de DAP",side=2,cex=1.7,line=3,family="serif")
mtext("Talho",side=1,cex=1.7,line=3,family="serif")
#locator(1)#para localizar a posio para inserir texto no grafico
text(1,23,"a",family="serif")


##GRFICO MDIA E DESVIO PADRAO   

saligna=read.csv("esaligna.csv", header=T,sep=",", dec=".",as.is=T)
saligna

#Transformando talhao em fator para poder calcular a mdia e o desv padrao do dap por talhao.

talhaofator=factor(saligna$talhao)

#Calculando a mdia dos daps por talho
(media.dap=tapply(X=saligna$dap,INDEX=talhaofator,FUN=mean))

#Clculando os desvios padro dos daps por talho
(sd.dap=tapply(X=saligna$dap,INDEX=talhaofator, FUN=sd))

#plano de trabalho (par())j foi estabelecido antes... continuando, segundo grfico:

plot(media.dap, cex.axis= 1.5, las=1, family="serif", tcl=0.3,col="red", xlab="", ylab="", ylim= c(0,25), pch=19, cex=1,bty="l")
mtext("Talho", line=3,side= 1, cex= 1.7, family="serif")  
mtext("Mdia do DAP",line=3,side=2,cex=1.7,family="serif")
points(media.dap + sd.dap, pch="-", cex= 1.5)#adicionando as barras superiores dos desvios padrao
points(media.dap - sd.dap, pch="-", cex= 1.5)#adicionando as barras inferiores dos desvios padro

#adicionando as linhas dos desvios padres de DAP para cada Talho
lines(x=c(1,1),y=c(media.dap[1]-sd.dap[1],media.dap[1]+sd.dap[1]))
lines(x=c(2,2),y=c(media.dap[2]-sd.dap[2],media.dap[2]+sd.dap[2]))
lines(x=c(3,3),y=c(media.dap[3]-sd.dap[3],media.dap[3]+sd.dap[3]))
lines(x=c(4,4),y=c(media.dap[4]-sd.dap[4],media.dap[4]+sd.dap[4]))
lines(x=c(5,5),y=c(media.dap[5]-sd.dap[5],media.dap[5]+sd.dap[5]))
lines(x=c(6,6),y=c(media.dap[6]-sd.dap[6],media.dap[6]+sd.dap[6]))

#locator(1)
text(1.5,25,"b",family="serif")

png(file = "saligna.png", bg = "transparent")

dev.off()
graphics.off()


########################### CDIGO GRAFICOS exercicio 3 ###############################

---- faltou na linha de tenencia , definir tamanho e colocar em negrito

#GRFICO 1

graphics.off()

?lm
#Reproduzir os grficos

(exercicio3=read.csv("exercicio3.csv", header=T,sep=",", dec=".",as.is=T))

head(exercicio3)
class(exercicio3)

#definindo o plano para oncluir as figuras
par(mfrow=c(1, 2))

#tirando os valores NA e o valor que no aparece na figura 
eixo.x=exercicio3$x1[-c(23,28,29,30,31)]
eixo.y=exercicio3$y1[-c(23,28,29,30,31)]

?abline

#ACHO QUE  SEM O LOG! os dados j esto "arrumados"
 
model=lm(eixo.y~eixo.x)
plot(eixo.y~eixo.x,tcl=0.3,cex.axis=1,pch=17,bty="l",family="serif",ylim=c(0,3),xlab="",ylab="")
abline(model)

mtext("Euclidean distances",side=2,cex=1.3,line=3, family="serif")
mtext("Log(Patch size)(ha)",side=1,cex=1.3,line=3,family="serif")
#locator(1)
text(2,3,"a",family="serif")

#GRAFICO 2

eixo.x2=exercicio3$x2
eixo.y2=exercicio3$y2

par(tcl=0.3,bty="l",family="serif",cex.axis=1)
boxplot(eixo.x2~eixo.y2, data=saligna,tcl=3,las=1,outline=FALSE,names=c("Small","Medium Edge","Medium Interior","Large Edge","Large Interior","Control"),ylim=c(0,3))
#locator(1)
text(6,3,"b",family="serif")
#locator(1)
text(1,3,"*",family="serif")
text(2,3,"*",family="serif")
text(3,3,"**",family="serif")
text(4,3,"*",family="serif")
text(5,3,"***",family="serif")

jpeg(filename = "exercicio3.jpg", width = 1009, height = 554)

dev.off()
graphics.off()

