#O modelo mais simples possvel

library(MASS)
data(Animals)
str(Animals)

anim.m2=lm(log(brain)~log(body),data=Animals, 
              subset=!(log(Animals$body)>8&log(Animals$brain)<6))

anim.m0=lm(log(brain)~1, data=Animals, 
              subset=!(log(Animals$body)>8&log(Animals$brain)<6))

anim.m2
plot(anim.m0)
summary(anim.m0)
summary(anim.m2)

#m0 - 

anova(anim.m0,anim.m2)
#teste trocando a ordem....
anova(anim.m2,anim.m0)

# 1. Qual a relao do comando 'anova' acima com a de baixo?
anova(anim.m2)

#s o modelo nulo... 
anova(anim.m0)

#RESP: A funo anova compara dois ou mais modelos de mesma natureza.
A funo implica, independente do nmero de modelos que quero comparar,
no teste dos modelos com o modelo nulo (i.e. sem intercepto), porm ela no devolve
os parmetros gerados pelo modelo nulo, a no ser que seja inserido no codigo da
funo anova o nome do objeto nulo. Isso pde ser notado quando as duas anovas em 
questo foram executadas; as estimativas do modelo gerado atravs das
observaes no foram alteradas.

# 2. Qual a relao entre os valores obtidos por estes comandos:

summary(anim.m0)
mean(log(Animals$brain[!(log(Animals$body)>8&log(Animals$brain)<6)]))
sd(log(Animals$brain[!(log(Animals$body)>8&log(Animals$brain)<6)]))

?summary

#RESP: a funo summary devolve o resumo dos resultados produzidos por funes.
Nesse caso em especfico, ele devolve os resultados do modelo nulo (i.e. sem intercepto) da regresso 
linear, em que o valor estimado do intercepto e o desvio padro dos resduos 
corresponde  mdia e ao desvio padro da varivel resposta, respectivamente.

?update
anim.m0 = update(anim.m2, .~. -log(body))
anim.m0
